
// (c) COPYRIGHT URI/MIT 1998
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for AsciiList. See AsciiByte.cc
//
// 3/12/98 jhrg

// $Log: AsciiList.cc,v $
// Revision 1.1  1998/03/13 21:25:17  jimg
// Added
//

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>

#include <Pix.h>
#include <SLList.h>
#include <String.h>

#include "AsciiList.h"
#include "name_map.h"

extern bool translate;
extern name_map names;

List *
NewList(const String &n, BaseType *v)
{
    return new AsciiList(n, v);
}

BaseType *
AsciiList::ptr_duplicate()
{
    return new AsciiList(*this);
}

AsciiList::AsciiList(const String &n, BaseType *v) : List(n, v)
{
}

AsciiList::~AsciiList()
{
}

bool 
AsciiList::read(const String &, int &)
{
    assert(false);
    return false;
}

void 
AsciiList::print_val(ostream &os, String, bool print_decl_p)
{
    // Print the name and size of the variable. Note that I print the size
    // information while initializing the vector #shape#. 3/9/98 jhrg
    if (print_decl_p)
	os << names.lookup(name(), translate) << ", ";
    
    int len = length();
    for (int i = 0; i < len; ++i) {
	BaseType *v = var(i);
	bool print_name_p = false;

	if (v->is_constructor_type())
	    print_name_p = true;

	var(i)->print_val(os, "", print_name_p);
	if (i < len-1)		// Comma after all but last element
	    os << ", ";
    }
}
