// -*- C++ -*-

// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Interface for ClientFloat64 type. See ClientByte.h
//
// jhrg 1/12/95

// $Log: ClientFloat64.h,v $
// Revision 1.6  1998/09/16 23:02:24  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.5  1998/08/03 16:39:46  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.4  1997/10/04 00:40:01  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.3  1996/10/23 23:46:50  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:00:35  jimg
// Fixed Headers.
//
// Revision 1.1  1996/09/30 23:59:01  jimg
// Added.

#ifndef _ClientFloat64_h
#define _ClientFloat64_h 1

#ifdef __GNUG__
#pragma interface
#endif

#include "Float64.h"

class ClientFloat64: public Float64 {
public:
    ClientFloat64(const String &n = (char *)0);
    virtual ~ClientFloat64() {}

    virtual BaseType *ptr_duplicate();
    
    virtual bool read(const String &dataset, int &error);

    virtual void print_val(ostream &os, String space = "", 
			   bool print_decl_p = true);
};

#endif

