
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation of ClientFunction. See ClientByte.cc
//
// jhrg 1/13/95

// $Log: ClientFunction.cc,v $
// Revision 1.11  1998/09/16 23:02:19  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.10  1998/08/03 16:39:46  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.9  1997/10/04 00:40:01  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.8  1997/04/19 00:54:51  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.7  1997/02/06 20:43:34  jimg
// Fixed log messages
//
// Revision 1.6  1997/01/10 06:49:30  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.5  1996/11/23 05:12:06  jimg
// Added support for variable renaming via the name_map object.
//
// Revision 1.4  1996/10/25 23:17:34  jimg
// Changed/Fixed write_val() so that it uses smart_newline().
// Fixed count_elements().
//
// Revision 1.3  1996/10/23 23:46:38  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:03:58  jimg
// Fixed Header.
// write_val is still broken.
//
// Revision 1.1  1996/09/30 23:59:03  jimg
// Added.

#ifdef _GNUG_
#pragma implementation
#endif

#include <assert.h>

#include <iostream.h>
#include <Pix.h>
#include <SLList.h>
#include <String.h>

#include "debug.h"
#include "ClientFunction.h"
#include "name_map.h"

extern name_map names;

extern bool write_val(BaseType *, ostream &, XDR *, DDS *, bool, bool);
extern void smart_newline(ostream &os, Type type);

Function *
NewFunction(const String &n)
{
    return new ClientFunction(n);
}

// protected

BaseType *
ClientFunction::ptr_duplicate()
{
    return new ClientFunction(*this);
}

// public

ClientFunction::ClientFunction(const String &n) : Function(n)
{
}

ClientFunction::~ClientFunction()
{
}

bool
ClientFunction::read(const String &, int &)
{
    assert(false);
    return false;
}

