
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// implementation for ClientGrid. See ClientByte.
//
// jhrg 10/4/96

// $Log: ClientGrid.cc,v $
// Revision 1.12  1998/11/20 08:41:22  jimg
// Fixed the fix for the extra newline separators; it was broken for arrays
//
// Revision 1.11  1998/09/16 23:02:20  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.10  1998/08/03 16:39:47  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.9  1997/10/04 00:40:02  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.8  1997/04/19 00:54:52  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.7  1997/02/06 20:43:36  jimg
// Fixed log messages
//
// Revision 1.6  1997/01/10 06:49:31  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.5  1996/11/23 05:12:07  jimg
// Added support for variable renaming via the name_map object.
//
// Revision 1.4  1996/10/25 23:07:30  jimg
// Fixed output of Grids so that the array and map parts can be recognized by
// loaddods.
//
// Revision 1.3  1996/10/23 23:46:39  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:04:40  jimg
// Fixed Header.
// Added a write_val() that works.
//
// Revision 1.1  1996/09/30 23:59:06  jimg
// Added.

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>
#include <Pix.h>
#include <SLList.h>
#include <String.h>

#include "ClientGrid.h"
#include "name_map.h"

extern name_map names;
extern bool translate;

Grid *
NewGrid(const String &n)
{
    return new ClientGrid(n);
}

BaseType *
ClientGrid::ptr_duplicate()
{
    return new ClientGrid(*this);
}

ClientGrid::ClientGrid(const String &n) : Grid(n)
{
}

ClientGrid::~ClientGrid()
{
}

bool
ClientGrid::read(const String &, int &)
{
    assert(false);
    return false;
}

void
ClientGrid::print_val(ostream &os, String space, bool print_decl_p)
{
    if (print_decl_p) {
	os << type_name() << endl << names.lookup(name(), translate) << endl;

	// We can only store one array in a grid right now.
	os << "array 1" << endl;
    }

    array_var()->print_val(os, space, print_decl_p);
    os << endl;

    if (print_decl_p) {
	os << "maps ";
	int i = 0;
	for (Pix p = first_map_var(); p; next_map_var(p))
	    ++i;
	os << i << endl;
    }

    for (Pix p = first_map_var(); p; next_map_var(p)) {
	map_var(p)->print_val(os, space, print_decl_p);
	os << endl;
    }
}
