
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientList. See ClientByte.cc
//
// jhrg 1/12/95

// $Log: ClientList.cc,v $
// Revision 1.12  1998/11/19 20:53:33  jimg
// Fixed the extra newline bug.
//
// Revision 1.11  1998/09/16 23:02:21  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.10  1998/08/03 16:39:49  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.9  1997/10/04 00:40:04  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.8  1997/04/19 00:54:55  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.7  1997/02/06 20:43:38  jimg
// Fixed log messages
//
// Revision 1.6  1997/01/10 06:49:34  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.5  1996/11/23 05:12:10  jimg
// Added support for variable renaming via the name_map object.
//
// Revision 1.4  1996/10/25 23:11:33  jimg
// Changed/Fixed write_val() so that it uses smart_newline().
//
// Revision 1.3  1996/10/23 23:46:42  jimg
// Modified so that writeval outputs a `recursive' data stream. Thus any
// data type can be written and later read without being flattened. This
// change was made so that the NSCAT data which is represented as a Sequence
// of Structures.
//
// Revision 1.2  1996/10/07 21:00:26  jimg
// Fixed Headers.
//
// Revision 1.1  1996/09/30 23:59:12  jimg
// Added.

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>

#include <Pix.h>
#include <SLList.h>
#include <String.h>

#include "ClientList.h"
#include "name_map.h"

extern name_map names;
extern bool translate;

extern void smart_newline(ostream &os, Type type);

List *
NewList(const String &n, BaseType *v)
{
    return new ClientList(n, v);
}

BaseType *
ClientList::ptr_duplicate()
{
    return new ClientList(*this);
}

ClientList::ClientList(const String &n, BaseType *v) : List(n, v)
{
}

ClientList::~ClientList()
{
}

bool 
ClientList::read(const String &, int &)
{
    assert(false);
    return false;
}

void 
ClientList::print_val(ostream &os, String, bool print_decl_p)
{
    if (print_decl_p) {
	os << type_name() << endl << var()->type_name() << " " 
	   << names.lookup(name(), translate) << " " << length() << endl;
    }

    for (int i = 0; i < length(); ++i)
	var(i)->print_val(os, "", false);
}
