
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for ClientInt32. See ClientByte.cc
//
// jhrg 11/1/96

// $Log: ClientUInt32.cc,v $
// Revision 1.12  1998/11/20 08:41:22  jimg
// Fixed the fix for the extra newline separators; it was broken for arrays
//
// Revision 1.11  1998/11/19 20:53:33  jimg
// Fixed the extra newline bug.
//
// Revision 1.10  1998/09/16 23:02:23  jimg
// Removed write_val() and replaced it with print_val() and print_all_vals()
//
// Revision 1.9  1998/08/03 16:39:52  jimg
// Fixed write_val mfunc so that outermost is no longer used
//
// Revision 1.8  1997/10/04 00:40:09  jimg
// Added changes to support the new deserialize() mfunc and write_val().
//
// Revision 1.7  1997/06/06 04:02:29  jimg
// Added ASCII output option to writeval. Uses a global `flag'.
//
// Revision 1.6  1997/04/19 00:55:00  jimg
// Changed ouput stream to simplify reading (for loaddods).
//
// Revision 1.5  1997/02/06 20:43:42  jimg
// Fixed log messages
//
// Revision 1.4  1997/01/10 06:49:39  jimg
// Changed call to name_map::lookup() so that non-alphanumerics are mapped to
// underscore. 
//
// Revision 1.3  1997/01/08 21:33:51  jimg
// Changed `dods_int32' to `dods_uint32' in ClientUInt32::write_val().
//
// Revision 1.2  1996/11/23 05:12:16  jimg
// Added support fr variable renaming via the name_map object.
//
// Revision 1.1  1996/11/02 00:03:25  jimg
// Added.
//

#ifdef __GNUG__
#pragma implementation
#endif

#include <assert.h>
#include <iostream.h>

#include <Pix.h>
#include <SLList.h>
#include <String.h>

#include "ClientUInt32.h"
#include "name_map.h"

extern name_map names;
extern bool ascii;
extern bool translate;

UInt32 *
NewUInt32(const String &n)
{
    return new ClientUInt32(n);
}

ClientUInt32::ClientUInt32(const String &n) : UInt32(n)
{
}

BaseType *
ClientUInt32::ptr_duplicate()
{
    return new ClientUInt32(*this);
}

bool
ClientUInt32::read(const String &, int &)
{
    assert(false);
    return false;
}

void 
ClientUInt32::print_val(ostream &os, String, bool print_decl_p)
{
    if (print_decl_p)
	os << type_name() << endl << names.lookup(name(), translate) << endl;

    if (translate) {
	dods_float64 df = _buf;
	if (ascii)
	    os << df << " ";
	else
	    os.write((void *)&df, sizeof(dods_float64));
    }
    else {
	if (ascii)
	    os << _buf << " ";
	else
	    os.write((void *)&_buf, sizeof(dods_uint32));
    }	
}



